<template>
    <modal
        name="invoice-preview"
        height="auto"
        :shift-y="0.2"
        :click-to-close="false"
        :scrollable="true"
        @before-open="beforeOpen"
        @before-close="beforeClose"
    >
        <div class="modal-header">
            <h5 class="modal-title">Invoice Preview</h5>

            <div class="close" @click="$modal.hide('invoice-preview')">
                <span aria-hidden="true">&times;</span>
            </div>
        </div>

        <div
            v-if="invoice"
            class="modal-body"
            style="background-color: #fdfdfd"
        >
            <div class="text-center">
                <img
                    src="/images/logo.png"
                    alt=""
                    style="margin: 0 auto; width: 150px"
                />
            </div>
            <div class="pdf-wrapper">
                <div class="text-center" style="line-height: 1.25">
                    <p>
                        Друштво за изучување на странски јазици, трговија и
                        услуги
                    </p>
                    <p>СТУДИО ГЛОСА ДООЕЛ Скопје</p>
                </div>
                <div style="margin-top: 20px; line-height: 1.25">
                    <p style="margin: 0px">
                        Жиро сметка {{ invoice.bank.account }}
                    </p>
                    <p style="margin: 0px">
                        {{ invoice.bank.name }}
                    </p>
                    <p style="margin: 0px">
                        Единствен даночен број : {{ invoice.bank.edb }}
                    </p>
                    <p style="margin: 0px">
                        {{ invoice.bank.stree }}
                    </p>
                    <p style="margin: 0px">Тел. {{ invoice.bank.phone }}</p>
                    <p style="margin: 0px">ул. Ѓорче Петров бр. 34, Скопје</p>
                </div>
                <table style="margin-top: 20px; width: 100%">
                    <tr>
                        <td
                            style="
                                width: 50%;
                                padding: 0px;
                                vertical-align: baseline;
                            "
                        >
                            <b style="font-size: 22px">ФАКТУРА</b>
                            {{ invoice.number }}
                        </td>
                        <td
                            style="
                                width: 50%;
                                padding: 0px;
                                vertical-align: baseline;
                            "
                        >
                            До:
                        </td>
                    </tr>
                    <tr>
                        <td style="width: 50%">
                            Датум на фактура:
                            {{ invoice.date | moment("DD.MM.YYYY") }}
                        </td>
                        <td style="width: 50%; line-height: 1.25">
                            <p>{{ invoice.customer.name }}</p>
                            <p>{{ invoice.customer.street }}</p>
                            <p>{{ invoice.customer.city }}</p>
                        </td>
                    </tr>
                </table>

                <table
                    style="
                        margin-top: 20px;
                        width: 100%;
                        border-collapse: collapse;
                    "
                    class="producs-table"
                >
                    <thead>
                        <tr>
                            <th
                                class="v-baseline text-center"
                                style="padding: 5px; width: 60px"
                            >
                                Р. бр.
                            </th>
                            <th
                                class="v-baseline text-center"
                                style="
                                    padding: 5px;
                                    width: 300px;
                                    line-height: 1.25;
                                "
                            >
                                Опис
                            </th>
                            <th
                                class="v-baseline text-center"
                                style="padding: 5px; width: 25px"
                            >
                                Стр.
                            </th>
                            <th
                                class="v-baseline text-center"
                                style="
                                    padding: 5px;
                                    width: 80px;
                                    line-height: 1.25;
                                "
                            >
                                <p>Ед. цена</p>
                                <p>(МКД)</p>
                            </th>
                            <th
                                class="v-baseline text-center"
                                style="
                                    padding: 5px;
                                    width: 50px;
                                    line-height: 1.25;
                                "
                            >
                                <p>Попуст</p>
                                <p>(%)</p>
                            </th>
                            <th
                                class="v-baseline text-center"
                                style="
                                    padding: 5px;
                                    width: 50px;
                                    line-height: 1.25;
                                "
                            >
                                <p>Износ</p>
                                <p>(МКД)</p>
                            </th>
                        </tr>
                    </thead>
                    <tbody>
                        <tr v-for="(item, index) in invoice.packages">
                            <td
                                class="text-center"
                                style="padding: 5px; width: 60px"
                            >
                                {{ index + 1 }}
                            </td>
                            <td
                                style="
                                    padding: 5px;
                                    width: 300px;
                                    line-height: 1.25;
                                "
                            >
                                <p>{{ item.name }}</p>
                            </td>
                            <td
                                class="text-center"
                                style="padding: 5px; width: 25px"
                            >
                                {{ item.pivot.quantity }}
                            </td>
                            <td
                                class="text-center"
                                style="padding: 5px; width: 80px"
                            >
                                {{ item.price | digit }}
                            </td>
                            <td
                                class="text-center"
                                style="padding: 5px; width: 50px"
                            >
                                <span v-if="item.pivot.discount"
                                    >{{ item.pivot.discount }}%</span
                                >
                                <span v-else>0%</span>
                            </td>
                            <td
                                class="text-center"
                                style="padding: 5px; width: 50px"
                            >
                                <span v-if="item.pivot.discount">
                                    {{
                                        (
                                            item.pivot.quantity * item.price -
                                            ((item.pivot.quantity *
                                                item.price) /
                                                100) *
                                                item.pivot.discount
                                        ).toFixed(0) | digit
                                    }}
                                </span>
                                <span v-else>
                                    {{
                                        (
                                            item.pivot.quantity * item.price
                                        ).toFixed(0) | digit
                                    }}
                                </span>
                            </td>
                        </tr>
                        <tr>
                            <td />
                            <td />
                            <td />
                            <td />
                            <th style="text-align: right">Вкупно:</th>
                            <th class="text-center">
                                {{ total.toFixed(0) | digit }}
                            </th>
                        </tr>
                    </tbody>
                </table>
                <p class="font-12">Фирмата не е ДДВ обврзник</p>
                <p v-if="invoice.notes.length && invoice.notes[0].flag">
                    {{ invoice.notes[0].description }}
                </p>
                <p>Рокот за подмирување на фактурата е 5 работни дена</p>
            </div>
            <div class="text-center">
                <img
                    src="/images/signature1.png"
                    alt=""
                    style="margin: 0 auto; width: 90%"
                />
            </div>
        </div>

        <div class="modal-footer">
            <button class="btn btn-primary" @click="generate()">
                Generate PDF
            </button>
        </div>
    </modal>
</template>

<script>
export default {
    filters: {
        digit(value) {
            if (!value) return "";
            var parts = value.toString().split(".");
            parts[0] = parts[0].replace(/\B(?=(\d{3})+(?!\d))/g, ".");
            parts[0] += ",00";
            return parts.join(",");
        },
    },
    data() {
        return {
            url: window.location.host,
            invoice: null,
            total: 0,
        };
    },

    methods: {
        beforeOpen(event) {
            this.invoice = event.params.invoice;

            for (let i = 0; i < this.invoice.packages.length; i++) {
                let sum;
                if (
                    this.invoice.packages[i].pivot.discount &&
                    this.invoice.packages[i].pivot.discount != 0
                ) {
                    sum =
                        this.invoice.packages[i].pivot.quantity *
                            this.invoice.packages[i].price -
                        ((this.invoice.packages[i].pivot.quantity *
                            this.invoice.packages[i].price) /
                            100) *
                            this.invoice.packages[i].pivot.discount;
                } else {
                    sum =
                        this.invoice.packages[i].pivot.quantity *
                        this.invoice.packages[i].price;
                }

                this.total += sum;
            }
        },

        beforeClose(event) {
            this.total = 0;
        },

        generate() {
            axios({
                method: "post",
                url: "/api/invoices/generatePDF",
                data: {
                    content: document.querySelector(".pdf-wrapper").innerHTML,
                },
                responseType: "blob",
            }).then((response) => {
                const url = window.URL.createObjectURL(
                    new Blob([response.data])
                );

                const link = document.createElement("a");
                link.href = url;
                link.setAttribute("download", this.invoice.number + ".pdf");
                document.body.appendChild(link);
                link.click();
            });
        },
    },
};
</script>

<style scoped>
.v-bottom {
    vertical-align: bottom;
}

.v-baseline {
    vertical-align: baseline;
}

p {
    margin: 0px;
}

.producs-table td,
.producs-table th {
    border: 1px solid grey;
    padding: 5px;
}

.font-12 {
    font-size: 12px;
}
</style>
